module OfflineDeployer
  class Tagger
    def tag(tag_name, tag_message, commit = nil)
      `git tag -a #{tag_name} -m "#{tag_message}" #{commit.presence}`
      puts "Created new tag - #{tag_name}"
      puts 'If you want to make a new release, run release maker.'
    end

    def tag_list
      `cd #{app_root} && git tag -l #{tag_list_sort}`.split("\n")
    end

    def fetch_tags
      `cd #{app_root} && git fetch --tags`
    end

    private

    def tag_list_sort
      Rails.env.development? ? '--sort=-version:refname' : '| sort -Vr'
    end

    def app_root
      OfflineDeployer.settings.app_root
    end
  end
end
